//*****************************************
// AT mega328P-AU(32pin TQFP) Six Nixie Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:ad_conv.c
//
//  2016/09/16 Taishi
//*****************************************
#include				<avr/io.h>

#include	"six_nixie.h"
#include	"ad_conv.h"

int				ad6_data[N_of_AD_data];
int				ad6_ave;
unsigned char	ad6_count;
// *******************************************************
// ************************* A/D 6 ***********************
// *******************************************************

//*****************************************
// A/D 6 Initial
// @荞ݕs̏ԂŌĂ΂Ƃ
//  ADC6: High Volt Monitor Max. about 0.55V (512 = 200V)
//*****************************************
void	ad6_init(void)
{
	unsigned char	i;

	ad6_count = 0;
	for(i = 0; i < N_of_AD_data; i++){
		ad6_data[i] = 0;
	}
	ad6_ave = 0;

//	DDRC &= ~(1 << DDC0);																	// Port-C Bit0 : Input

	PRR &= ~( 1 << PRADC );																	// A/D ғ
//	DIDR0 |= (1 << ADC0D);																	// AiO͐ݒ PD0

	ADMUX = ( (1 << REFS1) | (0 << REFS0) | (0 << MUX3) | (1 << MUX2) | (1 << MUX1) | (0 << MUX0) );	// PDPudgp, Select ADC6
	ADCSRA = ( (1 << ADEN) | (1 << ADSC) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) );				// A/D, A/DϊJn, CK/128=8MHz/128=62.5kHz(16uS) --> 208uS

}
//*****************************************
// A/D 6 close
//*****************************************
void	ad6_close(void)
{
	ADCSRA = 0;																				// A/Ds
}
//*****************************************
// A/D 6 Set A/D data to Data Buffer
//  ϊIĂȂ́@Ȃ
//*****************************************
void	ad6_set_data(void)
{
	if( (ADCSRA & (1 << ADIF)) != 0){								// `^cϊ
		ADCSRA |= (1 << ADIF);										// `^cϊtO폜
		ad6_data[ad6_count] = ADCW;
		ad6_count++;
		ad6_count &= (N_of_AD_data - 1);

		ADCSRA |= (1 << ADSC);										// A/DϊJn
	}
}
//*****************************************
// A/D 6 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
//  擾f[^ ad0_ave ɓ
//*****************************************
void	ad6_get_data(void)
{
	unsigned char	i;
	unsigned int	sum;

	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += ad6_data[i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	ad6_ave = sum;
}
