//*****************************************
// AT mega328P-AU(32pin TQFP) Six Nixie Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:eep_dat.c
//
//  2016/09/16 Taishi
//  2016/09/27 Modify Taishi v1.01 EEPROM-DATA ҏW̕\ύX
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/eeprom.h>

#include	"six_nixie.h"
#include	"port_bit.h"
#include	"timer.h"
#include	"ad_conv.h"
#include	"nixie.h"
#include	"eep_dat.h"

unsigned char	eep_keta EEMEM = 6;				// ۑ  2,4,6
unsigned char	eep_path EEMEM = 3;				// ۑ \Ԉ 1--4 (1:bright -- 4:dark)

static	unsigned char	eep_bf[10];

//*****************************************
//@ddoqnl KETA ǂݍ
//*****************************************
unsigned char	read_eep_keta(void)
{
	unsigned char	r = 6;

	eeprom_busy_wait();
	eep_bf[0] = eeprom_read_byte(&eep_keta);		// Ǐo
	if(eep_bf[0] == 2){
		r = 2;
	}else if(eep_bf[0] == 4){
		r = 4;
	}else{
		r = 6;
	}

	return(r);
}
//*****************************************
//@ddoqnl PATH ǂݍ
//*****************************************
unsigned char	read_eep_path(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bf[0] = eeprom_read_byte(&eep_path);		// Ǐo
	if((1 <= eep_bf[0])&&(eep_bf[0] <= 4)){
		r = eep_bf[0];
	}else{
		r = 1;
	}

	return(r);
}

//*****************************************
//@ddoqnl KETA 
//*****************************************
void	write_eep_keta(unsigned char uc)
{
	eep_bf[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_keta, eep_bf[0]);		// 
	eeprom_busy_wait();
}
//*****************************************
//@ddoqnl PATH 
//*****************************************
void	write_eep_path(unsigned char uc)
{
	eep_bf[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_path, eep_bf[0]);		// 
	eeprom_busy_wait();
}
//*****************************************
//@ddoqnlKETAҏW
//*****************************************
void	edit_eep_keta(void)
{
	unsigned char	uc;
	unsigned char	keta;
	unsigned char	blk_stat = 0;
	unsigned char	blink_time = 30;					// uNԊu

	keta = g_keta;
	disp_dynamic_nixie_number(0, path_limit);
	disp_dynamic_nixie_number(1, keta);
	disp_dynamic_colon(2);

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_action_sw();									// XCb`Ԃ
		uc = uc & SW_MASK;										// XCb`ɂ

		if(tim_10ms_blink == 0){								// _Ń^C~O̎
			tim_10ms_blink = blink_time;
			if((blk_stat==0)&&((uc & SW_ON) == 0)){				// ꂢȂ ł̎
				blk_stat = 1;
				disp_dynamic_nixie_number(1, 15);
			}else{
				blk_stat = 0;
				disp_dynamic_nixie_number(1, keta);
			}
		}

		if(uc != 0){											// EANVL鎞
			if((uc & SW_ON_CONTINUE) != 0){						// ꑱ
				if(keta == 2){
					keta = 4;
				}else if(keta == 4){
					keta = 6;
				}else{
					keta = 2;
				}
				disp_dynamic_nixie_number(1, keta);				// l̂P\
				tim_10ms_blink = blink_time;					// uNԊu
			}else if((uc & SW_OFF_SHORT) != 0){					// Zꂽ
				g_keta = keta;
				cli();
				write_eep_keta(g_keta);							//@ddoqnl KETA ɏ
				sei();											// 荞݉
				break;
			}
		}

		stabilizer_200v();										// QOOuۂ
	}

}

//*****************************************
//@ddoqnlPATHҏW
//*****************************************
void	edit_eep_path(void)
{
	unsigned char	uc;
	unsigned char	pt;
	unsigned char	blk_stat = 0;
	unsigned char	blink_time = 30;					// uNԊu

	pt = path_limit;
	disp_dynamic_nixie_number(1, g_keta);
	disp_dynamic_nixie_number(0, pt);
	disp_dynamic_colon(2);

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_action_sw();									// XCb`Ԃ
		uc = uc & SW_MASK;										// XCb`ɂ

		if(tim_10ms_blink == 0){								// _Ń^C~O̎
			tim_10ms_blink = blink_time;
			if((blk_stat==0)&&((uc & SW_ON) == 0)){				// ꂢȂ ł̎
				blk_stat = 1;
				disp_dynamic_nixie_number(0, 15);
			}else{
				blk_stat = 0;
				disp_dynamic_nixie_number(0, pt);
			}
		}

		if(uc != 0){											// EANVL鎞
			if((uc & SW_ON_CONTINUE) != 0){						// ꑱ

				led_on();										// LED ON
				delay_ms(100);									// 100mS Delay
				led_off();										// LED OFF
				delay_ms(100);									// 100mS Delay
				led_on();										// LED OFF
				delay_ms(100);									// 100mS Delay
				led_off();										// LED OFF

				if(4 <= pt){
					pt = 1;
				}else{
					pt++;
				}
				disp_dynamic_nixie_number(0, pt);				// l̂P\
				tim_10ms_blink = blink_time;					// uNԊu
			}else if((uc & SW_OFF_SHORT) != 0){					// Zꂽ
				cli();
				path_limit = pt;
				write_eep_path(path_limit);						//@ddoqnl PATH_LIMIT ɏ
				sei();											// 荞݉
				break;
			}
		}

		stabilizer_200v();										// QOOuۂ
	}

}

//*****************************************
//@ddoqnlDATAҏW
//  iv[v
//*****************************************
void	edit_eep_data(void)
{
	while(1){
		edit_eep_path();							// ddoqnlPATHҏW
		edit_eep_keta();							// ddoqnlKETAҏW
	}
}
