//*****************************************
// AT mega328P-AU(32pin TQFP) Six Nixie Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:set_rtc_2keta.c
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2016/03/26 Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"six_nixie.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"rtc_ds3234.h"
#include	"display.h"
#include	"nixie.h"
#include	"set_rtc_2keta.h"


//*****************************************
// N킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_year_2keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ye;
	unsigned char	uc;
	unsigned char	r=0;

	ye = gRTC_year;
	disp_nixie_tow_h(ye);								// N Q\

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_action_sw();						// XCb`Ԃ
		uc &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((uc & SW_ON) == 0)){	// ĂȂ ł̎
				blk_stat = 1;
				disp_nixie_tow_h(0xff);				// uN Q\
			}else{
				blk_stat = 0;
				disp_nixie_tow_h(ye);					// N Q\
			}
		}

		if(uc != 0){								// NVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc & SW_ON_CONTINUE) != 0){			// ꑱ
				ye++;
				if(9 < (ye & 0x0f)){				// X𒴂
					ye &= 0xf0;
					ye += 0x10;
				}
				if(0x99 < ye){
					ye = 0;
				}
			}else if((uc & SW_OFF_SHORT) != 0){		// Zꂽ
				if(gRTC_year == ye){				// lύXĂȂ
					r = 0;
				}else{
					gRTC_year = ye;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
		stabilizer_200v();							// QOOuۂ
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_month_2keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mo;
	unsigned char	uc;
	unsigned char	r=0;

	mo = gRTC_mon;
	disp_nixie_tow_h(mo);							//  Q\
	disp_dynamic_colon(2);							// R㑤̂

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_action_sw();						// XCb`Ԃ
		uc &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((uc & SW_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				disp_nixie_tow_h(0xff);				// uN Q\
			}else{
				blk_stat = 0;
				disp_nixie_tow_h(mo);				//  Q\
			}
		}

		if(uc != 0){								// EANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc & SW_ON_CONTINUE) != 0){			// ꑱ
				mo++;
				if(9 < (mo & 0x0f)){				// X𒴂
					mo &= 0xf0;
					mo += 0x10;
				}
				if(0x12 < mo){
					mo = 1;
				}
			}else if((uc & SW_OFF_SHORT) != 0){		// Zꂽ
				if(gRTC_mon == mo){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_mon = mo;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
		stabilizer_200v();							// QOOuۂ
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_day_2keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	da;
	unsigned char	uc;
	unsigned char	r=0;
	unsigned char	uru=0;
	unsigned char	syo=0;

	if(((((gRTC_year/16)*10)+(gRTC_year/16))/4) == 0){	// 邤N
		uru=1;
	}
	if((gRTC_mon == 0x04)||(gRTC_mon == 0x06)||(gRTC_mon == 0x09)||(gRTC_mon == 0x11)){	// ̌
		syo=1;
	}
	da = gRTC_day;
	disp_nixie_tow_h(da);							//  Q\
	disp_dynamic_colon(2);							// 㑤R

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_action_sw();						// XCb`Ԃ
		uc &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((uc & SW_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				disp_nixie_tow_h(0xff);				// uN Q\
				disp_dynamic_colon(0);				// RȂ
			}else{
				blk_stat = 0;
				disp_nixie_tow_h(da);				//  Q\
				disp_dynamic_colon(2);				// 㑤R
			}
		}

		if(uc != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc & SW_ON_CONTINUE) != 0){			// ꑱ
				da++;
				if(9 < (da & 0x0f)){				// X𒴂
					da &= 0xf0;
					da += 0x10;
				}
				if(syo == 1){						// ̌
					if(0x30 < da){
						da = 1;
					}
				}else if(gRTC_mon == 0x02){
					if(uru == 1){					// Q 邤N
						if(0x29 < da){
							da = 1;
						}
					}else{							// Q N
						if(0x28 < da){
							da = 1;
						}
					}
				}else{								// ̌
					if(0x31 < da){
						da = 1;
					}
				}
			}else if((uc & SW_OFF_SHORT) != 0){		// Zꂽ
				if(gRTC_day == da){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_day = da;
					rtc_write();					// RTC 
				}
				break;								// I
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
		stabilizer_200v();							// QOOuۂ
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_hour_2keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ho;
	unsigned char	uc;
	unsigned char	r=0;

	ho = gRTC_hou;
	disp_nixie_tow_h(ho);							//  Q\
	disp_dynamic_colon(2);							// R㑤̂

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_action_sw();						// XCb`Ԃ
		uc &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((uc & SW_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				disp_nixie_tow_h(0xff);				// uN Q\
			}else{
				blk_stat = 0;
				disp_nixie_tow_h(ho);				//  Q\
			}
		}

		if(uc != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc & SW_ON_CONTINUE) != 0){			// ꑱ
				ho++;
				if(9 < (ho & 0x0f)){				// X𒴂
					ho &= 0xf0;
					ho += 0x10;
				}
				if(0x23 < ho){
					ho = 0;
				}
			}else if((uc & SW_OFF_SHORT) != 0){		// Zꂽ
				if(gRTC_hou == ho){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_hou = ho;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
		stabilizer_200v();							// QOOuۂ
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_minute_2keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mi;
	unsigned char	uc;
	unsigned char	r=0;

	mi = gRTC_min;
	disp_nixie_tow_h(mi);							//  Q\
	disp_dynamic_colon(0);							// RȂ

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_action_sw();						// XCb`Ԃ
		uc &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((uc & SW_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				disp_nixie_tow_h(0xff);				// uN Q\
				disp_dynamic_colon(2);				// R㑤̂
			}else{
				blk_stat = 0;
				disp_nixie_tow_h(mi);				//  Q\
				disp_dynamic_colon(0);				// RȂ
			}
		}

		if(uc != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc & SW_ON_CONTINUE) != 0){			// ꑱ
				mi++;
				if(9 < (mi & 0x0f)){				// X𒴂
					mi &= 0xf0;
					mi += 0x10;
				}
				if(0x59 < mi){
					mi = 0;
				}
			}else if((uc & SW_OFF_SHORT) != 0){		// Zꂽ
				if(gRTC_min == mi){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_min = mi;
					gRTC_sec = 0;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
		stabilizer_200v();							// QOOuۂ
	}

	return(r);
}
//*****************************************
// Qv킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
// @̊֐ł QOOũtB[hobN͊|ĂȂ
// @@ԂẐł̂܂܂ŗǂƂ
//*****************************************
unsigned char	proc_set_rtc_2keta(void)
{
	unsigned char	r;

	r = proc_set_year_2keta();						// N킹
	if(r == 0){
		r = proc_set_month_2keta();					// 킹
		if(r == 0){
			r = proc_set_day_2keta();				// 킹
			if(r == 0){
				r = proc_set_hour_2keta();			// 킹
				if(r == 0){
					r = proc_set_minute_2keta();	// 킹
				}
			}
		}
	}
	return(r);
}

