//*****************************************
// AT mega328P-AU(32pin TQFP) Six Nixie Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:six_nixie.c
//
//  2016/09/16 New    Taishi v1.00
//  2016/09/27 Modify Taishi v1.01 `FbN̓ύXAEEPROM-DATA ҏW̕\ύX
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"six_nixie.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"display.h"
#include	"ad_conv.h"
#include	"nixie.h"
#include	"rtc_ds3234.h"
#include	"set_rtc.h"
#include	"eep_dat.h"

unsigned char			g_keta;

static	unsigned char	run=0;
static	unsigned char	dc_match=0;
static	int				bef1_ad6_ave=0;
static	unsigned char	num_count=0;
static	unsigned char	renzoku[16]={1,7,2,8,0,6,3,9,4,5,15,15,15,15,15,15};			// ̑w̑w
static	unsigned char	gyaku_renzoku[16]={5,4,9,3,6,0,8,2,7,1,15,15,15,15,15,15};		// ̑w牺̑w


//***************************
// f[^o͑삷
//***************************
void	output_data(void)
{
	if(run == 0){					// nee̎
		pulse_out = PULSE_OUT_MAX;
		run = 1;					// nm
	}else{							// nm̎
		pulse_out = 0;
		run = 0;					// nee
	}
}
//***************************
// `^c̒lłnmpXω
//  `^cl ad6_ave ɂ
//  pX pulse_out ɓ
//***************************
void	feed_back_pro(void)
{
	int		p;
	int		nxt_ad6_ave;
	int		sa;

	p = pulse_out;
	sa = ad6_ave - bef1_ad6_ave;
	if(0 < sa){											// o̎
		nxt_ad6_ave = ad6_ave + sa + sa;				// \l傫
	}else{
		nxt_ad6_ave = ad6_ave + sa;
	}

	if (ad6_ave == LEVEL_AD){							// ڕWl̎
		;
	}else if (ad6_ave < LEVEL_AD){						// ܂Ⴂ
		if(LEVEL_AD_L <= ad6_ave){						// ڕWlɗƍl
			p += OUT_BAND;								// ۂ͉Ȃ
		}else if(LEVEL_AD_NL <= nxt_ad6_ave){			// ڕWlɖwǋ߂Âƍl
			p += OUT_NEAR;								// ω
		}else if(LEVEL_AD_ML <= nxt_ad6_ave){			// ڕWlɑ啪߂Âƍl
			p += OUT_MID;								// ω
		}else if(nxt_ad6_ave < LEVEL_AD_ML){			// ڕWlɉƍl
			p += OUT_FAR;								// 傫ω
		}
	}else if (LEVEL_AD < ad6_ave){						// ܂
		if(ad6_ave <= LEVEL_AD_H){						// ڕWlɗƍl
			p -= OUT_BAND;								// ۂ͉Ȃ
		}else if(nxt_ad6_ave <= LEVEL_AD_NH){			// ڕWlɖwǋ߂Âƍl
			p -= OUT_NEAR;								// ω
		}else if(nxt_ad6_ave <= LEVEL_AD_MH){			// ڕWlɑ啪߂Âƍl
			p -= OUT_MID;								// ω
		}else if(LEVEL_AD_MH < nxt_ad6_ave){			// ڕWlɉƍl
			p -= OUT_FAR;								// 傫ω
		}
	}

	if(p < PULSE_OUT_MIN){
		p = PULSE_OUT_MIN;
	}else if(PULSE_OUT_MAX < p){
		p = PULSE_OUT_MAX;
	}

	if((LEVEL_AD - 200) < nxt_ad6_ave){						// QOOO̎
		if(25 < sa){										// ωʂRT𒴂Ă鎞
			p = 200;
		}
	}

	pulse_out = p;

	if((LEVEL_LED_L <= ad6_ave)&&(ad6_ave <= LEVEL_LED_H)){	// kdc_͈͂ɗƍl
		dc_match=1;
	}else{
		dc_match=0;
	}

	bef1_ad6_ave = ad6_ave;
}
//***************************
// QOOuۂ
//***************************
void	stabilizer_200v(void)
{
	if(tim_10ms_ad == 0){
		tim_10ms_ad = 10;									// 100mS Ԋuł`^cf[^擾
		ad6_get_data();										// ρ@A/D l̎擾
		feed_back_pro();
		set_timer1_ontime();
		if(dc_match==1){
			led_on();										// LED ON
			dynamic_nixie_active(1);
		}else{
			led_off();										// LED OFF
		}
	}
}

//***************************
// `FbNs
//***************************
void	check(void)
{
	unsigned char	uc;
	unsigned char	old_run = 0;
	unsigned char	kazu = 0;
	unsigned char	keta = 0;
	unsigned char	old_keta = 1;
	unsigned char	pause = 0;

	led_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_off();										// LED OFF

	get_sw();

	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	old_run = run;
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	bef1_ad6_ave = 0;
	output_data();									// f[^o͑삷
	disp_dynamic_nixie_number(1, 8);
	disp_dynamic_nixie_number(0, 8);
	disp_dynamic_colon(2);
	led_off();										// LED OFF
	pulse_on();
	tim_10ms_ad = 0;
	for(;;){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ
		if(uc == SW_OFF_LONG){									// XCb`NbNꂽ
			bef1_ad6_ave = 0;
			output_data();										// f[^o͑삷
			edit_eep_data();									// ddoqnlDATAҏWiiv[vj
		}

		if(uc == SW_OFF_SHORT){									// XCb`NbNꂽ
			break;
		}
		stabilizer_200v();										// QOOuۂ
	}


	for(;;){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ

		if(uc == SW_OFF_SHORT){									// XCb`NbNꂽ
			pause ^= 1;
		}

		if(tim_10ms_blink == 0){
			tim_10ms_blink = 100;							// 1000mS Ԋu
			if(pause == 0){
				disp_dynamic_nixie_dot(old_keta,0);				// _
				if(old_keta != keta){							// ς
					disp_dynamic_nixie_number(old_keta, 15);	// Ǒ̐
					old_keta = keta;
				}
				if(kazu == 10){
					disp_dynamic_nixie_dot(keta,1);				// _
					disp_dynamic_nixie_number(keta, 15);		// 
				}else{
					disp_dynamic_nixie_number(keta, kazu);		// 
				}
				kazu++;
				if((keta == 1) || (keta == 3)){
					if(10 < kazu){								// Oɖ߂
						kazu = 0;
						keta++;
						if((g_keta - 1) < keta){				// \߂
							keta = 0;
						}
					}
				}else{
					if(10 <= kazu){								// Oɖ߂
						kazu = 0;
						keta++;
						if((g_keta - 1) < keta){				// \߂
							keta = 0;
						}
					}
				}
			}
		}
		stabilizer_200v();										// QOOuۂ
	}

}
//***************************
// Aj[V\
//@ODPbɌĂ΂
// 
//@FP̂
// ߂l
//@OAj[Vr
//@PAj[VI
//***************************
unsigned char	disp_animation(unsigned char init)
{
	static	unsigned char	ani_count1 = 0;		//  0--5
	static	unsigned char	ani_count2 = 0;		// l 0--9, 10=colon
	unsigned char			r = 0;
	unsigned char			count2_max = 9;

	if (init == 1){
		ani_count1 = 0;
		ani_count2 = 0;
	}else{
		if(ani_count2 == 0){
			for(ani_count2=0;ani_count2 <= (g_keta - 1);ani_count2++){
				disp_dynamic_nixie_number(ani_count2, 15);
			}
			ani_count2 = 0;
		}

		if((ani_count1 & 1) == 0){									// 
			disp_dynamic_nixie_number(ani_count1, renzoku[ani_count2]);
			disp_dynamic_colon(0);
			count2_max = 9;
		}else{														// E
			disp_dynamic_nixie_number(ani_count1, gyaku_renzoku[ani_count2]);
			if((g_keta != 2)&&((g_keta - 1) == ani_count1)){
				count2_max = 9;
			}else{
				count2_max = 10;
			}
			if(ani_count2 == 10){
				if(g_keta == 6){
					if(ani_count1 == 1){
						disp_dynamic_colon(2);						// 㑤R
					}else if(ani_count1 == 3){
						disp_dynamic_colon(1);						// R
					}
				}else if(g_keta == 4){
					if(ani_count1 == 1){
						disp_dynamic_colon(2);						// 㑤R
					}
				}else{
					disp_dynamic_colon(2);						// 㑤R
				}
			}
		}
		ani_count2++;
		if(count2_max < ani_count2){
			ani_count2 = 0;
			ani_count1++;								// ̌
			if((g_keta - 1) < ani_count1){
				ani_count1 = 0;
				r = 1;
			}
		}
	}

	return(r);
}

//***************************
//  Up Main
//***************************
static	void	main_6keta(void)
{
	char			uc;
	unsigned char	disp_clock_mode=HMS;
	unsigned char	old_disp_clock_mode=HMS;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_sec = 0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;

	sei();											// 荞݉

	bef1_ad6_ave = 0;
	pulse_out = PULSE_OUT_MAX;
	pulse_on();										// 200V Output Start

	tim_10ms_nixie = 100;
	disp_dynamic_colon(3);

	while(1){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ
		if(uc == SW_OFF_LONG){									// ꂽ
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			disp_clock_mode = HMS;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
		}else if(uc == SW_OFF_SHORT){							// Zꂽ
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HMS:
				disp_clock_mode = YMD;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				break;
			 case YMD:
				disp_clock_mode = HMS;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 default:
				disp_clock_mode = HMS;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else{
			if(rtc_1s_flg != old_rtc_1s_flg){				// qsbĂ鎞̂Pboߗp
				old_rtc_1s_flg = rtc_1s_flg;
				rtc_read();									// RTC ǂݏo
				if(disp_clock_mode == HMS){					// b[h
					if((old_RTC_hou != gRTC_hou)||(old_RTC_min != gRTC_min)||(old_RTC_sec != gRTC_sec)){	//  bω
						disp_nixie_six(gRTC_hou,gRTC_min,gRTC_sec);		// ƕƕb U\
						disp_dynamic_colon(3);
						old_RTC_hou = gRTC_hou;
						old_RTC_min = gRTC_min;
						old_RTC_sec = gRTC_sec;
						if((gRTC_min == 0)&&(gRTC_sec == 0)){		// ̎
							disp_clock_mode = ANIME;
							disp_animation(1);						// Aj[V
							old_disp_clock_mode = HMS;
							disp_dynamic_colon(3);
						}
					}
				}else if(disp_clock_mode == YMD){					// N[h
					disp_dynamic_colon(3);
					tim_10ms_nixie = 50;							// TOOr^C}[d|
					if((old_RTC_year != gRTC_year)||(old_RTC_mon != gRTC_mon)||(old_RTC_day != gRTC_day)){	// Nω
						disp_nixie_six(gRTC_year,gRTC_mon,gRTC_day);		// NƌƓ U\
						old_RTC_year = gRTC_year;
						old_RTC_mon = gRTC_mon;
						old_RTC_day = gRTC_day;
					}
				}
				num_count=0;
			}

			if (proc_no_key_timeup(0) == 0xff){				// ԃL[͂
				if((disp_clock_mode != HMS)&& (disp_clock_mode != ANIME)){	// \ŖŁAAjł
					disp_clock_mode = HMS;
				}
			}

			if(tim_10ms_nixie == 0){								// TOO
				if(disp_clock_mode == ANIME){						// Aj[V̎
					tim_10ms_nixie = 20;							// POOr^C}[d|
					if(disp_animation(0) == 1){						// \
						disp_clock_mode = old_disp_clock_mode;
						old_RTC_sec = 0xff;
						old_RTC_min = 0xff;
						old_RTC_hou = 0xff;
						old_RTC_mon = 0xff;
						old_RTC_day = 0xff;
						old_RTC_year = 0xff;
					}
				}else if(disp_clock_mode == YMD){					// N̎
					disp_dynamic_colon(0);
				}
			}
		}
		stabilizer_200v();										// QOOuۂ
	}

}

//***************************
//  Sp Main
//***************************
static	void	main_4keta(void)
{
	char			uc;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_disp_clock_mode=HM;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;

	sei();											// 荞݉

	bef1_ad6_ave = 0;
	pulse_out = PULSE_OUT_MAX;
	pulse_on();										// 200V Output Start

	tim_10ms_nixie = 100;

	while(1){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ
		if(uc == SW_OFF_LONG){									// ꂽ
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			disp_clock_mode = HM;
			old_RTC_min = 0xff;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
		}else if(uc == SW_OFF_SHORT){							// Zꂽ
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				break;
			 case MD:
				disp_clock_mode = YE;
				old_RTC_year = 0xff;
				break;
			 case YE:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			 default:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else{
			if(rtc_1s_flg != old_rtc_1s_flg){				// qsbĂ鎞̂Pboߗp
				old_rtc_1s_flg = rtc_1s_flg;
				rtc_read();									// RTC ǂݏo
				if(disp_clock_mode == HM){					// [h
					disp_dynamic_colon(3);					// R\ _
					tim_10ms_nixie = 50;
					if((old_RTC_hou != gRTC_hou)||(old_RTC_min != gRTC_min)){	//  ω
						disp_nixie_four(gRTC_hou,gRTC_min);		// ƕ S\
						old_RTC_hou = gRTC_hou;
						old_RTC_min = gRTC_min;
						if((gRTC_min == 0)&&(gRTC_sec == 0)){	// ̎
							disp_dynamic_colon(0);				// R\ 
							disp_clock_mode = ANIME;
							disp_animation(1);					// Aj[V
							old_disp_clock_mode = HM;
						}
					}
				}else if((disp_clock_mode == MD)&&((old_RTC_mon != gRTC_mon)||(old_RTC_day != gRTC_day))){	// [h ω
					disp_nixie_four(gRTC_mon,gRTC_day);		// Ɠ S\
					old_RTC_mon = gRTC_mon;
					old_RTC_day = gRTC_day;
					disp_dynamic_colon(3);					// R\ _
				}else if((disp_clock_mode == YE)&&(old_RTC_year != gRTC_year)){	// N[h Nω
					disp_nixie_four(0x20,gRTC_year);		// N S\
					old_RTC_year = gRTC_year;
					disp_dynamic_colon(0);					// R\ 
				}
				num_count=0;
			}

			if (proc_no_key_timeup(0) == 0xff){				// ԃL[͂
				if((disp_clock_mode != HM)&& (disp_clock_mode != ANIME)){	// \ŖŁAAjł
					disp_clock_mode = HM;
				}
			}

			if(tim_10ms_nixie == 0){						// TOO
				if(disp_clock_mode == ANIME){			// Aj[V̎
					tim_10ms_nixie = 20;						// POOr^C}[d|
					if(disp_animation(0) == 1){					// \
						disp_clock_mode = old_disp_clock_mode;
						old_RTC_hou = 0xff;
						old_RTC_min = 0xff;
						old_RTC_mon = 0xff;
						old_RTC_day = 0xff;
						old_RTC_year = 0xff;
					}
				}else if(disp_clock_mode == HM){				// ̎
					disp_dynamic_colon(0);						// R\ 
				}
			}
		}
		stabilizer_200v();										// QOOuۂ
	}
}

//***************************
// Qpv̕\
// step : 0 -> 3 0=hour,month,year(H)  1=minute,day,year(L) 2=Number 0--9 fast scrol 3=Blank
// change: sec change now
// mode: disp mode
//***************************
static	void	disp_clock_2keta(unsigned char step, unsigned char change, unsigned mode)
{

	if(step == 0){
		if(mode == HM){								// \̎
			if((gRTC_hou & 0xf0)==0){				// iʌO̎j
				disp_nixie_tow_h(0xf0 | gRTC_hou);	//  ̂ݕ\
			}else{
				disp_nixie_tow_h(gRTC_hou);			//  Q\
			}
		}else if(mode == MD){						// \̎
			if((gRTC_mon & 0xf0)==0){				// iʌO̎j
				disp_nixie_tow_h(0xf0 | gRTC_mon);	//  ̂ݕ\
			}else{
				disp_nixie_tow_h(gRTC_mon);			//  Q\
			}
		}else if(mode == YE){						// N\̎
			disp_nixie_tow_h(0x20);					// QO Q\
		}else{										// ̑i͖͂j
			disp_nixie_tow_h(0x20);					// QO Q\
		}
		disp_dynamic_colon(0);						// RȂ
	}else if(step == 1){
		if(mode == HM){								// \̎
			if((gRTC_min & 0xf0)==0){				// iʌO̎j
				disp_nixie_tow_h(0xf0 | gRTC_min);	//  ̂ݕ\
			}else{
				disp_nixie_tow_h(gRTC_min);			//  Q\
			}
		}else if(mode == MD){						// \̎
			if((gRTC_day & 0xf0)==0){				// iʌO̎j
				disp_nixie_tow_h(0xf0 | gRTC_day);	//  ̂ݕ\
			}else{
				disp_nixie_tow_h(gRTC_day);			//  Q\
			}
			disp_dynamic_colon(1);					// 㑤R
		}else if(mode == YE){						// N\̎
			disp_nixie_tow_h(gRTC_year);			// N Q\
		}else{										// ̑i͖͂j
			disp_nixie_tow_h(gRTC_year);			// N Q\
		}
		disp_dynamic_colon(2);						// 㑤R
	}else if(step == 2){
		disp_nixie_tow_h((renzoku[num_count] << 4) | gyaku_renzoku[num_count]);	// \
		disp_dynamic_colon(0);						// RȂ
		num_count++;
	}else if(step == 3){
		disp_nixie_tow_h(0xff);						// uN
		disp_dynamic_colon(2);						// 㑤R
	}else{
		disp_nixie_tow_h(0xff);						// uN
		disp_dynamic_colon(2);						// 㑤R
	}
}
//***************************
//  Qp Main
//***************************
static	void	main_2keta(void)
{
	char			uc;
	unsigned char	disp_clock_step=3;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_rtc_1s_flg=0xff;


	sei();											// 荞݉

	bef1_ad6_ave = 0;
	pulse_out = PULSE_OUT_MAX;
	pulse_on();										// 200V Output Start
	tim_10ms_nixie = 100;

	while(1){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ
		if(uc == SW_OFF_LONG){									// ꂽ
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			disp_clock_mode = HM;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
			disp_clock_step = 3;
		}else if(uc == SW_OFF_SHORT){							// Zꂽ
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				break;
			 case MD:
				disp_clock_mode = YE;
				break;
			 case YE:
				disp_clock_mode = HM;
				break;
			 default:
				disp_clock_mode = HM;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
			disp_clock_step = 3;
			tim_10ms_nixie = 0;
		}else{
			if(tim_10ms_nixie == 0){							// POO
				tim_10ms_nixie = 10;
				if(rtc_1s_flg != old_rtc_1s_flg){				// qsbĂ鎞̂Pboߗp
					old_rtc_1s_flg = rtc_1s_flg;
					rtc_read();									// RTC ǂݏo
					disp_clock_2keta(disp_clock_step, 1, disp_clock_mode);	// v̕\
					disp_clock_step++;
					if(3 < disp_clock_step){
						disp_clock_step = 0;
					}
					num_count=0;
				}else{
					disp_clock_2keta(disp_clock_step, 0, disp_clock_mode);	// v̕\
				}

				if (proc_no_key_timeup(0) == 0xff){				// ԃL[͂
					if(disp_clock_mode != HM){					// \Ŗ
						disp_clock_mode = HM;
						disp_clock_step = 3;
					}
				}
			}
		}
		stabilizer_200v();										// QOOuۂ
	}

}
//***************************
//  Main
//***************************
int	main(void)
{

#if	0
	char			uc;
	unsigned char	disp_clock_mode=HMS;
	unsigned char	old_disp_clock_mode=HMS;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_sec = 0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;
#endif

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0) | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, Timer0, Timer1, Timer2, ADC ~
	delay_ms(200);									// 200mS Delay


	init_nixe();									// Nixe\ 
	sw_init();										// XCb`֌W̏ݒ
	rtc_init();										// qsb̏ݒ
	led_init();										// kdc֌W̏ݒ
	timer1_init();									// Timer1 Initial
	timer2_init();									// Timer2 Initial
	ad6_init();										// A/D 6 Initial
	g_keta = read_eep_keta();						// ddoqnl KETA ǂݍ
	path_limit = read_eep_path();					// ddoqnl PATH_limit ǂݍ

	if((PIND & SW_ON_BIT) == 0){					// XCb`f[^Ă
		check();									// `FbNs
	}

	if(g_keta == 2){								// \Q̎
		main_2keta();								// Qp Main
	}else if(g_keta == 4){							// \S̎
		main_4keta();								// Sp Main
	}else{
		main_6keta();								// Up Main
	}

}
